var NUM_PAGES = 500;
var PAGE_WIDTH = 595;
var PAGE_HEIGHT = 842;
var HORIZONTAL_MARGIN = 30;
var TOP_MARGIN = 70;

var stream;
var callback;

function generatePdf() {
    var doc = new PDFDocument({autoFirstPage: false});
    stream = doc.pipe(blobStream());
    stream.on("finish", function() {
        callback(stream.toBlob("application/pdf"));
    });

    var startTime = Date.now();
    var counter = 0;
    for (var page = 0; page < NUM_PAGES; page++) {
        doc.addPage({margin: 0, size: "A4"});
        var nextLineAt = TOP_MARGIN;
        while (nextLineAt < PAGE_HEIGHT - HORIZONTAL_MARGIN - 25) {
            var nextColumnAt = HORIZONTAL_MARGIN;
            while (nextColumnAt < PAGE_WIDTH - HORIZONTAL_MARGIN - 100) {
                counter++;
                doc.text("Cell number " + counter, nextColumnAt, nextLineAt);
                nextColumnAt += 100;
            }
            nextLineAt += 25;
        }
    }
    console.log(Date.now() - startTime);
    doc.end();
}

function setCallback(cb) {
    callback = cb;
}
